<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE task PUBLIC "-//OASIS//DTD DITA Task//EN" "task.dtd">
<task id="wht-task-pt-xslt-import">
  <title>How to Use XSLT Extension Points from a Publishing Template</title>
  <shortdesc>This example demonstrates how to use WebHelp XSLT-import Extension Points from an <xref
      href="whr-publishing-template.dita"><term>Oxygen Publishing
    Template</term></xref>.</shortdesc>
  <task id="dd">
    <title>Use Case 1: Add Copyright Information Extracted from a DITA Bookmap</title>
    <taskbody>
      <context>
        <p id="p_um4_cgk_54b">Suppose you want to customize the WebHelp Responsive main page by adding information
          about the legal rights associated with the book in the footer (for example, copyright
          dates and owner). This information is specified in the bookmap:</p>
        <codeblock  id="codeblock_vm4_cgk_54b">&lt;bookrights>            
  &lt;copyrfirst>
    &lt;year>2002&lt;/year>
  &lt;/copyrfirst>
  &lt;copyrlast>
    &lt;year>2017&lt;/year>
  &lt;/copyrlast>
  &lt;bookowner>
    &lt;organization>SyncRO Soft SRL&lt;/organization>                
  &lt;/bookowner>
&lt;/bookrights></codeblock>
        <p id="p_wm4_cgk_54b">
          <fig id="fig_zdk_x3b_ycb">
            <title>Example: Copyright Information Added in the WebHelp Footer</title>
            <image href="../img/WH-XSLT-customization.png" id="image_a2k_x3b_ycb"/>
          </fig>
        </p>
        <p id="p_xm4_cgk_54b">The XSLT stylesheet that generates the main page is located in:
              <filepath><term keyref="glossentry_dita_ot_dir"
            />\plugins\com.oxygenxml.webhelp.responsive\xsl\mainFiles\createMainPage.xsl</filepath>.
          This XSLT stylesheet declares the <codeph>copy_template</codeph> mode that processes the
            <xref href="html_page_templates.dita#html_page_templates/main-page">main page
            template</xref> to expand its components. The main page template declares a component
          for the footer section that looks like this:</p>
        <codeblock  id="codeblock_ym4_cgk_54b">&lt;div class=" footer-container text-center ">
  &lt;whc:include_html href="${webhelp.fragment.footer}"/>
&lt;/div></codeblock>
        <p id="p_zm4_cgk_54b">In the following example, the extension stylesheet will add a template that matches this
          component. It applies the default processing and adds the copyright information at the
          end.</p>
        <codeblock  id="codeblock_an4_cgk_54b">&lt;xsl:template match="*:div[contains(@class, 'footer-container')]" mode="copy_template">
  &lt;!-- Apply the default processing -->
  &lt;xsl:next-match/>
    
  &lt;!-- Add a div containing the copyright information -->
  &lt;div class="copyright_info">        
      &lt;xsl:choose>
          &lt;!-- Adds the start-end years if they are defined -->
          &lt;xsl:when test="exists($toc/*:topicmeta/*:bookrights/*:copyrfirst) and 
                              exists($toc/*:topicmeta/*:bookrights/*:copyrlast)">
              &lt;span class="copyright_years">
                 &amp;#xa9;&lt;xsl:value-of select="$toc/*:topicmeta/*:bookrights/*:copyrfirst"/>
                       -&lt;xsl:value-of select="$toc/*:topicmeta/*:bookrights/*:copyrlast"/>
              &lt;/span>
          &lt;/xsl:when>
            
          &lt;!-- Adds only the first year if last is not defined. -->
          &lt;xsl:when test="exists($toc/*:topicmeta/*:bookrights/*:copyrfirst)">
              &lt;span class="copyright_years">
                 &amp;#xa9;&lt;xsl:value-of select="$toc/*:topicmeta/*:bookrights/*:copyrfirst"/>
              &lt;/span>
          &lt;/xsl:when>
      &lt;/xsl:choose>
                    
        
      &lt;xsl:if test="exists($toc/*:topicmeta/*:bookrights/*:bookowner/*:organization)">
          &lt;span class="organization">
              &lt;xsl:text> &lt;/xsl:text>&lt;xsl:value-of 
                   select="$toc/*:topicmeta/*:bookrights/*:bookowner/*:organization"/>
              &lt;xsl:text>. All rights reserved.&lt;/xsl:text>
          &lt;/span>
      &lt;/xsl:if>
  &lt;/div>
&lt;/xsl:template></codeblock>
        <p id="p_bn4_cgk_54b">To add this functionality using a <abbreviated-form
            keyref="glossentry-wh-publishing-template"/>, follow these steps:</p>
      </context>
      <steps>
        <step>
          <cmd>If you have not already created a Publishing Template, see <xref
              href="whr-create-publishing-template.dita">How to Create a Publishing
            Template</xref>.</cmd>
        </step>
        <step>
          <cmd>Link the folder associated with the publishing template to your current project in
            the <uicontrol product="author developer editor webhelp-responsive ope"
              >Project</uicontrol><uicontrol product="authorEclipse developerEclipse editorEclipse"
              >Project Explorer</uicontrol> view.</cmd>
          <stepresult>You should have the <filepath>custom_footer_template</filepath> folder linked
            in your project.</stepresult>
        </step>
        <step>
          <cmd>Using the <uicontrol product="author developer editor webhelp-responsive ope"
              >Project</uicontrol><uicontrol product="authorEclipse developerEclipse editorEclipse"
              >Project Explorer</uicontrol> view, create an <filepath>xslt</filepath> folder inside the
            project root folder.</cmd>
          <stepresult>You should have the <filepath>custom_footer_template/xsl</filepath> folder in
            your project.</stepresult>
        </step>
        <step>
          <cmd>Create your customization stylesheet (for example, <b>custom_mainpage.xsl</b>) in the
              <filepath>custom_footer_template/xsl</filepath> folder. Edit it to override the
            template that produces the footer section:</cmd>
          <info>
            <codeblock  id="codeblock_cn4_cgk_54b">&lt;xsl:template match="*:div[contains(@class, 'footer-container')]" mode="copy_template">
  &lt;!-- Apply the default processing -->
  &lt;xsl:next-match/>

  &lt;!-- Add a div containing the copyright information -->
  &lt;div class="copyright_info">        
      &lt;xsl:choose>
          &lt;!-- Adds the start-end years if they are defined -->
          &lt;xsl:when test="exists($toc/*:topicmeta/*:bookrights/*:copyrfirst) and 
                        exists($toc/*:topicmeta/*:bookrights/*:copyrlast)">
              &lt;span class="copyright_years">
                 &amp;#xa9;&lt;xsl:value-of select="$toc/*:topicmeta/*:bookrights/*:copyrfirst"/>
                       -&lt;xsl:value-of select="$toc/*:topicmeta/*:bookrights/*:copyrlast"/>
              &lt;/span>
          &lt;/xsl:when>
            
          &lt;!-- Adds only the first year if last is not defined. -->
          &lt;xsl:when test="exists($toc/*:topicmeta/*:bookrights/*:copyrfirst)">
              &lt;span class="copyright_years">
                 &amp;#xa9;&lt;xsl:value-of select="$toc/*:topicmeta/*:bookrights/*:copyrfirst"/>
              &lt;/span>
          &lt;/xsl:when>
      &lt;/xsl:choose>
                    
        
      &lt;xsl:if test="exists($toc/*:topicmeta/*:bookrights/*:bookowner/*:organization)">
          &lt;span class="organization">
              &lt;xsl:text> &lt;/xsl:text>&lt;xsl:value-of 
                   select="$toc/*:topicmeta/*:bookrights/*:bookowner/*:organization"/>
              &lt;xsl:text>. All rights reserved.&lt;/xsl:text>
          &lt;/span>
      &lt;/xsl:if>
  &lt;/div>
&lt;/xsl:template></codeblock>
          </info>
        </step>
        <step>
          <cmd>Open the <xref href="whr_publishing_template_contents.dita#template_descritpor_file"
              >template descriptor file</xref> associated with your publishing template and set the
            XSLT stylesheet created in the previous step with the
              <term>com.oxygenxml.webhelp.xsl.createMainPage</term> XSLT extension point.</cmd>
        </step>
        <stepsection>
          <codeblock  id="codeblock_dn4_cgk_54b">&lt;publishing-template>
    ...
    &lt;webhelp>
        ...        
        &lt;xslt>
            &lt;extension 
            file="xslt/customMainPage.xsl" 
            id="com.oxygenxml.webhelp.xsl.createMainPage"/></codeblock>
        </stepsection>
        <step>
          <cmd>Open the <term>DITA Map WebHelp Responsive</term> transformation scenario.</cmd>
        </step>
        <step>
          <cmd>Click the <uicontrol>Choose Custom Publishing Template</uicontrol> link and select
            your template.</cmd>
        </step>
        <step>
          <cmd>Click <uicontrol>OK</uicontrol> to save the changes to the transformation
            scenario.</cmd>
        </step>
        <step>
          <cmd>Run the transformation scenario.</cmd>
        </step>
      </steps>
    </taskbody>
  </task>
  <task id="dd-uu">
    <title>Use Case 2: Add Generation Time in the Output Footer</title>
    <taskbody>
      <context id="context_j3p_tmc_ycb">
        <p id="p_en4_cgk_54b">Another possible customization for the main page is to add the generation time in its
          footer. A transformation parameter is used to control whether or not this customization is
          active. </p>
        <p id="p_fn4_cgk_54b">
          <fig id="fig_wjy_ldz_2bb">
            <title>Generation Time Added in the WebHelp Footer</title>
            <image href="../img/WH-XSLT-customization-gen-date.png" id="image_jlh_hdz_2bb"
              placement="inline"/>
          </fig>
        </p>
        <p id="p_gn4_cgk_54b">To add this functionality, follow these steps:</p>
      </context>
      <steps id="steps_rxg_ymc_ycb">
        <step>
          <cmd>In the customization stylesheet that you just created (for example,
              <b>custom_mainpage.xsl</b>), modify the template by adding the following XSLT code at
            the end.</cmd>
          <info>
            <codeblock  id="codeblock_hn4_cgk_54b">&lt;xsl:if test="oxyf:getParameter('webhelp.footer.add.generation.time') = 'yes'">
  &lt;div class="generation_time">
    Generation date: &lt;xsl:value-of 
    select="format-dateTime(
                   current-dateTime(), 
                   '[h1]:[m01] [P] on [M01]/[D01]/[Y0001].')"/>
  &lt;/div>
&lt;/xsl:if></codeblock>
          </info>
          <info>
            <note id="note_in4_cgk_54b">You can read the value of a WebHelp transformation parameter from your XSLT
              extension stylesheets by using the <codeph>getParameter(param.name)</codeph> function
              from the <codeph>http://www.oxygenxml.com/functions</codeph> namespace. </note>
          </info>
        </step>
        <step>
          <cmd>Open the <xref href="whr_publishing_template_contents.dita#template_descritpor_file"
              >template descriptor file</xref> associated with your publishing template and set the
              <codeph>webhelp.footer.add.generation.time</codeph> parameter to the default
            value.</cmd>
          <info>
            <codeblock  id="codeblock_jn4_cgk_54b">&lt;publishing-template>
    ...    
    &lt;webhelp>
      ...
      &lt;parameters>
        &lt;parameter 
          name="webhelp.footer.add.generation.time" 
          value="yes"/></codeblock>
          </info>
        </step>
        <step>
          <cmd>Open the <term>DITA Map WebHelp Responsive</term> transformation scenario.</cmd>
        </step>
        <step>
          <cmd>In the <uicontrol>Parameters</uicontrol> tab, you can change the value of the
              <codeph>webhelp.footer.add.generation.time</codeph> parameter.</cmd>
        </step>
        <step>
          <cmd>Click <uicontrol>OK</uicontrol> to save the changes to the transformation
            scenario.</cmd>
        </step>
        <step>
          <cmd>Run the transformation scenario.</cmd>
        </step>
      </steps>
    </taskbody>
  </task>
</task>
